{!    SAPI_DLL.DLL   ,    Windows\System !}
{
  Get Access to Speech API from DLL methods
  (c) Kirin Denis 2002-2003.  version 1.1 FREEWARE
  http://wtwsoft.narod.ru
  mailto:wtwsoft@narod.ru
}

{
               :

  CreateSpeech                  //     CreateSpeech  SAPI_DLL.Dll
  SelectEngine( name: string ); //  , SAPI    CreateSpeech
  Speak( text: string );        //     text.    , SelectEngine
  DestroySeech;                 //  SAPI client

    ...
         :

     ../SAPI_DLL_SOURCE/BaseUnit.pas
     ../SAPI_DLL_SOURCE/SpAPI.pas
     ../SAPI_DLL_SOURCE/SAPI.pas

}


unit Unit1;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SAPIInterface, StdCtrls, ComCtrls, AppEvnts;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    ComboBox1: TComboBox;
    Button3: TButton;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button4: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Memo1: TMemo;
    Label8: TLabel;
    Memo2: TMemo;
    Label10: TLabel;
    ApplicationEvents1: TApplicationEvents;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure UpDown2Changing(Sender: TObject; var AllowChange: Boolean);
    procedure UpDown3Changing(Sender: TObject; var AllowChange: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure EnableControlComponents;
    procedure DisableControlComponents;
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
  private
  public
  end;


var
  Form1: TForm1;

implementation

{$R *.DFM}
//Call back demo

procedure OnStart;
begin
  Form1.memo2.lines.Add('Start');
end;

procedure OnPause;
begin
  Form1.memo2.lines.Add('Pause');
end;

procedure OnResume;
begin
  Form1.memo2.lines.Add('Resume');
end;

procedure OnStop;
begin
  Form1.memo2.lines.Add('Stop');
end;

procedure OnUserStart;
begin
  Form1.memo2.lines.Add('User Start');
end;

procedure OnUserStop;
begin
  Form1.memo2.lines.Add('User Stop');
end;

procedure OnPosition(Position: integer);
begin
  Form1.memo2.lines.Add('Position: ' + IntToStr(Position));
  Form1.memo1.SelStart := 0;
  Form1.memo1.SelLength := Position;
end;

procedure OnSpeed(Position: integer);
begin
  Form1.memo2.lines.Add('Speed: ' + IntToStr(Position));
end;

procedure OnVolume(Position: integer);
begin
  Form1.memo2.lines.Add('Volume: ' + IntToStr(Position));
end;

procedure OnPitch(Position: integer);
begin
  Form1.memo2.lines.Add('Pitch: ' + IntToStr(Position));
end;

procedure OnSelectEngine(Number: integer; Name: string);
begin
  Form1.memo2.lines.Add('Select Engine: #' + IntToStr(Number) + ' name ' + Name);
end;

procedure OnStatusChange;
begin
  Form1.memo2.lines.Add('Status change ');
end;

procedure OnError(Text: string);
begin
  Form1.memo2.lines.Add('Error: ' + Text);
end;


procedure _OnStop;
begin
  Form1.memo2.lines.Add('Stop');
end;

//  SAPI.

procedure TForm1.Button1Click(Sender: TObject);
var
  Engines: TStrings;
  ECount: word;
begin
  if CreateSpeech = 0 then //     CreateSpeech  SAPI_DLL.Dll
  begin //   0   
    Engines := GetEngines; // GetEngines       
    ComboBox1.Items.Clear; //   TString( ),      
    for ECount := 0 to Engines.Count - 1 do //         ComboBox1
      ComboBox1.Items.Add(Engines[ECount]);
    ComboBox1.ItemIndex := 0; //   ComboBox1     

    Button4.Enabled := true;
    Button3.Enabled := true;
    ComboBox1.Enabled := true;
    Label5.Enabled := true;
    Label9.Enabled := true;

    RegistOnStart(@OnStart);
    RegistOnPause(@OnPause);
    RegistOnResume(@OnResume);
    RegistOnStop(@OnStop);
    RegistOnUserStart(@OnUserStart);
    RegistOnUserStop(@OnUserStop);
    RegistOnPosition(@OnPosition);
    RegistOnSpeed(@OnSpeed);
    RegistOnVolume(@OnVolume);
    RegistOnPitch(@OnPitch);
    RegistOnSelectEngine(@OnSelectEngine);
    RegistOnStatusChange(@OnStatusChange);
    RegistOnError(@OnError);
  end;
end;

//      

procedure TForm1.Button2Click(Sender: TObject);
begin
  Speak(memo1.text);
end;

//  , sapi   

procedure TForm1.Button3Click(Sender: TObject);
begin
  if ComboBox1.Text = '' then Exit;

//   ComboBox1        
// SelectEngine  sapi         Speak()



  SelectEngine(ComboBox1.Text);

//     , , 
//      ,    
//        

  UpDown1.Position := GetSpeed;
  UpDown1.Max := GetMaxSpeed;
  UpDown1.Min := GetMinSpeed;

  UpDown2.Position := GetVolume;
  UpDown2.Max := GetMaxVolume;
  UpDown2.Min := GetMinVolume;
  SetVolume(UpDown2.Position); //  bug  UpDown.OnChang

  UpDown3.Position := GetPitch;
  UpDown3.Max := GetMaxPitch;
  UpDown3.Min := GetMinPitch;

  EnableControlComponents;

end;

//  sapi

procedure TForm1.Button4Click(Sender: TObject);
begin
  DestroySpeech; //  SAPI client...
  DisableControlComponents;
end;

//   

procedure TForm1.UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
begin
  SetSpeed(UpDown1.Position);
end;

// 

procedure TForm1.UpDown2Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  SetVolume(UpDown2.Position);
end;

// 

procedure TForm1.UpDown3Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  SetPitch(UpDown3.Position);
end;

//       Alt-F4  SAPI

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DestroySpeech;
end;

// .   ,   

procedure TForm1.Button5Click(Sender: TObject);
begin
  Pause;
end;

//    .  .

procedure TForm1.Button6Click(Sender: TObject);
begin
  Resume;
end;

//  .  .   Resume .
//      - Reset Speak

procedure TForm1.Button7Click(Sender: TObject);
begin
  Stop;
end;

//----------------------------------------------------------------------------------------
//    .     
//      -  Speak, Rusume,  , .

procedure TForm1.EnableControlComponents;
begin
  Button2.Enabled := true;
  Button5.Enabled := true;
  Button6.Enabled := true;
  Button7.Enabled := true;

  Label6.Enabled := true;
  Label7.Enabled := true;
  Label8.Enabled := true;
  Label1.Enabled := true;
  Label2.Enabled := true;
  Label3.Enabled := true;

  Memo1.Enabled := true;
  Edit2.Enabled := true;
  Edit3.Enabled := true;
  Edit4.Enabled := true;

  UpDown1.Enabled := true;
  UpDown2.Enabled := true;
  UpDown3.Enabled := true;
end;

//     .  .

procedure TForm1.DisableControlComponents;
begin
  Button2.Enabled := false;
  Button4.Enabled := false;
  Button5.Enabled := false;
  Button6.Enabled := false;
  Button7.Enabled := false;

  Label6.Enabled := false;
  Label7.Enabled := false;
  Label8.Enabled := false;
  Label9.Enabled := false;
  Label1.Enabled := false;
  Label2.Enabled := false;
  Label3.Enabled := false;

  Memo1.Enabled := false;
  Edit2.Enabled := false;
  Edit3.Enabled := false;
  Edit4.Enabled := false;

  UpDown1.Enabled := false;
  UpDown2.Enabled := false;
  UpDown3.Enabled := false;

  Button3.Enabled := false;
  ComboBox1.Enabled := false;
  Label5.Enabled := false;
  Label9.Enabled := false;

end;
procedure TForm1.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
begin
 // DO somtning or bugs free application :)
end;

end. //  ...

